
# Julia codes for “Predictive online optimisation with applications to optical flow”

These are the Julia codes for the optical flow experiments of the manuscript _“Predictive online optimisation with applications to optical flow”_ by [Tuomo Valkonen](https://tuomov.iki.fi) ([arXiv:2002.03053](https://arxiv.org/abs/2002.03053)).

## Prerequisites

These codes were written for Julia 1.3. The Julia package prequisites are from November 2019 when our experiments were run, and have not been updated to maintain the same environment we used to do the experiments in the manuscript. You may get Julia from [julialang.org](https://julialang.org/). 

## Using

Navigate your unix shell to the directory containing this `README.md` and then run:

    $ julia --project=.

The first time doing this, to ensure all the dependencies are installed, run

    $ ]instantiate

Afterwards in the Julia shell, type:

    > using PredictPDPS

This may take a while as Julia precompiles the code. Then, to generate all the experiments in the manuscript, run:

    > batchrun_article()

This will save the results under `img/`.
To see the experiments running visually, and not save the results, run

    > demo_known1()

or any of `demo_XY()`, where `X`=1,2,3 and `Y`=`known`,`unknown`.
Further parameters and experiments are available via `run_experiments`. See the source code for details.

To run the data generation multi-threadeadly parallel to the algorithm, set the `JULIA_NUM_THREADS` environment variable to a number larger than one.
